#ifndef __QUAT_H__
#define __QUAT_H__

#include "types.h"

class SE3;
typedef std::vector<SE3> RigidDeform;

namespace Deform {
	namespace DeformAll_Utility {
		class SE3_6DOF;
		class RefWeight;
		typedef std::vector<SE3_6DOF> TransformList;
	}
}

void MatrixToUnitQuat( const Geometry::Matrix33f& m, real4_type& q );
void QuatTrans2UDQ( const real4_type& q0, const real3_type& t, real4_type& qn, real4_type& qd );
void UDQ2QuatTrans( const real4_type& qn, const real4_type& qd, real4_type& q0, real3_type& t );
void DQ2QuatTrans( const real4_type& qn, const real4_type& qd, real4_type& q0, real3_type& t );
void DQToMatrix( const real4_type& Qn, const real4_type& Qd, Geometry::Matrix33f& R, real3_type& t );

real3_type lbs(const real3_type& x, const data_type& weights, const RigidDeform& tfList, bool inverse );
real3_type dqs(const real3_type& x, const data_type& weights, const RigidDeform& tfList, bool inverse );
void lbs(const real3_type& x, real3_type& x_out, const Deform::DeformAll_Utility::RefWeight& weights, const Deform::DeformAll_Utility::TransformList& tfList, bool inverse );
void lbs(const real3_type& x, const real3_type& n, real3_type& x_out, real3_type& n_out, const Deform::DeformAll_Utility::RefWeight& weights, const Deform::DeformAll_Utility::TransformList& tfList, bool inverse );
void lbs(const real3_type& x, const real3_type& n, real3_type& x_out, real3_type& n_out, const data_type& weights, const RigidDeform& tfList, bool inverse );
void dqs(const real3_type& x, const real3_type& n, real3_type& x_out, real3_type& n_out, const data_type& weights, const RigidDeform& tfList, bool inverse );

#endif
