#ifndef DEFORMEDIT_H
#define DEFORMEDIT_H

#include <QWidget>
#include "ui_DeformEdit.h"
#include "ParamSelect.h"

class DeformEdit : public QWidget
{
	Q_OBJECT

public:
	DeformEdit(QWidget *parent = 0);
	~DeformEdit();

	void initRange( int which, double minRange, double maxRange, double initValue );
	void init_solveInitialRigidCheckBox( bool value );
	void init_solveFinalWeightsCheckBox( bool value );
	void init_correspondenceTypeCombo( int type );

private slots:
	void on_pauseSolverButton_clicked();
	void on_stepSolverButton_clicked();
	void on_solveFinalWeightsCheckBox_stateChanged(int);
	void on_RevertSolutionButton_clicked();
	void on_requestNextFrameButton_clicked();
	void on_AccumulateGeometryButton_clicked();
	void on_correspondenceTypeCombo_currentIndexChanged(int);
	void on_solveInitialRigidCheckBox_stateChanged(int);
	void on_OtherTasksComboBox_currentIndexChanged(int);
	void on_stopSolverButton_clicked();
	void on_inverseDeformButton_clicked();
	void on_exportResultButton_clicked();
	void on_solveDeformAutoButton_clicked();
	void on_solveDeformUpdateCorrespButton_clicked();
	void on_solveDeformWeightButton_clicked();
	void on_solveDeformTransformButton_clicked();
	void on_solveDeformInitButton_clicked();
	void on_setupDeformButton_clicked();
	void controlChanged(int id, double value);
	void on_outputStats_clicked();

private:
	Ui::DeformEditClass ui;
	std::vector<ParamSelect*> controls;

	void init();
	ParamSelect* findControl(int id);

signals:
	void valueChanged(int which, double value);
};

#endif // DEFORMEDIT_H
