#include <QApplication>
#include <libXMLParam/xmlParam.h>
#include "TransformViewer.h"
#include "viewer.h"
#include "scene.h"
#include "../Util/util.h"

using namespace std;

int main(int argc, char *argv[])
{
	QApplication a(argc, argv);
	xmlParam *par = new xmlParam();

	// Instantiate the scene.
	Scene scene;
	scene.setXMLParamList(*par);

	// Initialize timers.
	timerArray.resize(TIMER_NUM);

	// Check input parameters.
	if (par->initParamXML(argc, argv)) {
		//std::cout << "-------------------------------------------------------------------------------" << std::endl;
		//par->printParamsINI();
		//std::cout << "-------------------------------------------------------------------------------" << std::endl;

		// Instantiate the viewer.
		QGLFormat aGLFormat;
		aGLFormat.setSampleBuffers(true);
		aGLFormat.setSamples(16);
		Viewer viewer(&scene, aGLFormat);
		viewer.setWindowTitle("shapeAlign");
		viewer.show();

		// Start the application.
		return a.exec();
	}
	else
	{
		TransformViewer viewer(&scene);
		viewer.setWindowTitle("Shape Compare");
		viewer.show();

		// Start the application.
		return a.exec();
	}

	// Return an error.
	return 1;
}

void setXMLParamList(xmlParam &p)
{
	// populate the parameter list with your desired global variables
}